/****************************************************************************
* Archivo: PIE.PRG                                                          *
*                                                                           *
* Descripcin: Programa de demostracin de la funcin Graf_pie              *
*                                                                           *
* Compilar : CLIPPER PIE /m /n                                              *
*                                                                           *
* Encadenar : BLINKER FI PIE LIB LLIBG 		para modo real                 *
*				  EXOSPACE FI PIE LIB LLIBG      para modo protegido            *
*                                                                           *
* NOTA: Requiere CA-Clipper 5.3                                             *
*****************************************************************************/

#INCLUDE "LLIBG.CH"                              // necesario para trabajar en modo grfico

FUNCTION Main
	LOCAL aVals
	aVals        := {{10,"Compras"},{20,"Ventas"},{23,"Sueldos"},{45,"Gastos"},{15,"No deducibles"},{50,"Otros"},{34,"Varios"}}
	Graf_pie(aVals)
	aVals        := {{100,"CA-Clipper"},{85,"CA-Visual Objects"},{23,"CA-dBFast"},{10,"Windows 95"},{100,"Windows 3.x"}}
	Graf_pie(aVals)
	aVals        := {{200,"Hombres"},{205,"Mujeres"},{120,"Nios"},{100,"Nias"}}
	Graf_pie(aVals)
RETURN (NIL)
/* Fin Main */

/****************************************************************************
* Funcin: Graf_pie()                                                       *
*                                                                           *
* Sintxis : Graf_pie(<aValores>)                                           *
*				                                                                *
*            donde : <aValores> es un arreglo bidimensional que contiene en *
*							en el primer elemento el valor a graficar y en el      *
*							segundo una descripcin de dicho valor como cadena de  *
*							caracteres                                             *
*               	                                                          *
* Retorna : Nada                                                            *
*                                                                           *
* Descripcin : Genera una grfica de pie utilizando la funcin GELLIPSE()  *
*					 de CA-Clipper 5.3.                                          *
*                                                                           *
* Autor: Equipo de desarrollo de Cibertec.                                  *
*                                                                           *
* Fecha: 20/SEP/1995                                                        *
*                                                                           *
* NOTA : Requiere CA-Clipper 5.3                                            *
*****************************************************************************/

FUNCTION Graf_pie(aValores)

	LOCAL nSumavals := 0                          // para la suma total los valores del arreglo
	LOCAL nModoact                                // para guardar el modo de video actual
	LOCAL nAngIni   := 0                          // angulo inicial de la elipse
	LOCAL nAngFinal := 0                          // angulo final de la elipse
	LOCAL nReng     := 0                          // rengln para poner un mensaje
	LOCAL cValores                                // texto del mensaje

	/* guardamos el modo actual de video */

	nModoact := GMODE()

	/* activamos el modo grfico */

	GMODE(LLG_VIDEO_VGA_640_480_16)

	/* la magia de toda esta funcin se realiza en dos bloques de cdigo */

	/* obtenemos la suma total de todos los elementos del arreglo */

	AEVAL(aValores, {|nValor, nPos| nSumavals += nValor[1]})

	/* graficamos, para esto utilizamos un bloque de cdigo y una regla de
	   tres simple:

		1) Cada elemento del arreglo, dependiendo del valor, tendr una
		   "rebanada" del pie, la funcin GELLIPSE() permite graficar por
			angulos, asi que utilizamos una regla de tres para ver cuantos
			grados le tocan a cada valor:

							nSumaVal  -  360 grados
							nValor[1] -  x grados

           nAngFinal := nAngIni + ((nValor[1] * 360) / nSumaVals)

			Con esta informacin, determinamos nuestro angulo final de graficacin
			(nAngFinal) este cambia para cada valor a graficar, debido a que cada
			valor nuevo comienza donde termina el valor anterior, por esta razn
			debemos de sumarle la variable nAngIni (angulo de inicio)

	   2)  Con la informacin anterior graficamos una rebanada para cada valor:

 		GELLIPSE(320,240,200,100,nAngIni,nAngFinal,LLG_FILL,nPos,LLG_MODE_SET,0,20)

		3) Segn lo dicho anteriormente, el angulo final de este elemento
			graficado, se convierte ahora en el angulo inicial del siguiente
			elemento

		   nAngIni := nAngFinal

		4) Creamos un string con informacin sobre el valor graficado, con el
			segundo elemento del arreglo

		cValores := LTRIM(STR(nValor[1]))+" "+TRANSFORM((nValor[1] * 100) / nSumavals,"999.999")+ " % "+nValor[2],;

		5) Con la funcin GWRITEAT(), desplegamos la informacin del dato
			graficado

		GWRITEAT(20,nReng+5,cValores,nPos,LLG_MODE_SET),;

		6) Como cada caracter mide 16 pixeles de alto, le sumamos 20 al
			contador de pixeles verticales para que al siguiente valor a
			graficar, tengamos un espacio de aproximadamente un rengln

		nReng += 20

		*/

	AEVAL(aValores, {|nValor,nPos| nAngFinal := nAngIni + ((nValor[1] * 360) / nSumaVals),;
		GELLIPSE(320,240,200,100,nAngIni,nAngFinal,LLG_FILL,nPos,LLG_MODE_SET,0,20),;
		nAngIni := nAngFinal,;
		cValores := LTRIM(STR(nValor[1]))+" "+TRANSFORM((nValor[1] * 100) / nSumavals,"999.999")+ " % "+nValor[2],;
		GWRITEAT(20,nReng+5,cValores,nPos,LLG_MODE_SET),;
		nReng += 20})

	/* espera una tecla y retorna al modo de video inicial, sin olvidar borrar
		la pantalla */

	INKEY(0)
	GMODE(nModoact)
	CLEAR
RETURN(NIL)
/* Fin Graf_pie */

/* Fin PIE.PRG */
